; ##########################################################################

    Do_Status PROTO :DWORD

    .data
        hStatus       dd 0

    .code

; ##########################################################################

Do_Status proc hParent:DWORD

    LOCAL sbParts[ 10] :DWORD

    invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or \
                              SBS_SIZEGRIP,NULL, hParent, 200
    mov hStatus, eax
      
  ; -------------------------------------
  ; sbParts is a DWORD array of 8 members
  ; -------------------------------------
    mov [sbParts +  0], 300						; 300 pixels
    mov [sbParts +  4], 355						; set count: 55
    mov [sbParts +  8], 390						; set count value: 45
    mov [sbParts + 12], 460						; game count: 70
    mov [sbParts + 16], 505						; game count value: 45
    mov [sbParts + 20], 570						; error count: 65
    mov [sbParts + 24], 615						; error count value: 45
    mov [sbParts + 28], 685						; Elapsed time: 80
    mov [sbParts + 32], 780						;
    mov [sbParts + 36], -1						;

    invoke SendMessage,hStatus,SB_SETPARTS, 10,ADDR sbParts

    ret

Do_Status endp

; ##########################################################################

;*==========================================================================*
;* 				Routine to initialize the statusbar columns for use			*
;*==========================================================================*
start_status	proc
		        invoke  	SendMessage,hStatus,SB_SETTEXT,0, offset szWelcome
		        invoke  	SendMessage,hStatus,SB_SETTEXT,1, offset szSetCount
		        invoke  	SendMessage,hStatus,SB_SETTEXT,3, offset szGameCount
		        invoke  	SendMessage,hStatus,SB_SETTEXT,5, offset szEnergyLeft
		        invoke  	SendMessage,hStatus,SB_SETTEXT,7, offset szTimeLeft
		        ret
start_status	endp




; ##########################################################################

