;****************************************************************************
;*			File name: uChipfrm.asm											*
;*			Date created: 30th June 2009									*
;*			Author: Tan Ghee Siak											*
;****************************************************************************



;*==========================================================================*
;*			Routine to setup the controls for display						*
;*--------------------------------------------------------------------------*
;*			Variable: RunLine points to current set's start number			*
;*==========================================================================*
setup_form			proc	hWin:DWORD
					

					;*==============	Groupbox A 		=============================
				    invoke CreateWindowEx, NULL,
										   offset ButtonClass, offset szPortA, 50000007h,
										   16, 20, 270, 135, hWin, 600,
										   hInstance,NULL
					
					;*==============	Groupbox B 		=============================
				    invoke CreateWindowEx, NULL,
										   offset ButtonClass, offset szPortB, 50000007h,
										   300, 20, 270, 135, hWin, 601,
										   hInstance,NULL
					
					;*==============	Groupbox C 		=============================
				    invoke 	CreateWindowEx, NULL,
										   offset ButtonClass, offset szPortC, 50000007h,
										   16, 170, 270, 135, hWin, 602,
										   hInstance,NULL
					
					;*==============	Groupbox D 		=============================
				    invoke 	CreateWindowEx, NULL,
										   offset ButtonClass, offset szPortD, 50000007h,
										   300, 170, 270, 135, hWin, 603,
										   hInstance,NULL

					;*==============	Include msg label	=============================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szInclude, 50000000h,
       									  700, 10, 150, 12, hWin, 500,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Delay msg label	=============================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szPauseRtn, 50000000h,
       									  700, 23, 150, 12, hWin, 501,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Delay open brace msg label	===================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szOpenBrace, 50000000h,
       									  700, 36, 150, 12, hWin, 502,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Delay int msg label	===================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szInt, 50000000h,
       									  740, 49, 150, 12, hWin, 503,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Delay Nop msg label	===================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szNop, 50000000h,
       									  740, 75, 150, 12, hWin, 503,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Delay close brace msg label	===================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szCloseBrace, 50000000h,
       									  700, 88, 150, 12, hWin, 504,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Main msg label	===================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szMain, 50000000h,
       									  700, 101, 150, 12, hWin, 505,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Main open brace msg label	===================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szOpenBrace, 50000000h,
       									  700, 114, 150, 12, hWin, 506,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*==============	Delay open brace msg label	===================
				    invoke 	CreateWindowEx,NULL,
										  ADDR StaticClass, offset szCloseBrace, 50000000h,
       									  700, 505, 150, 12, hWin, 507,
       									  hInstance,NULL
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE


					;*==============	Draw Port A-D bit labels	=============================
					mov		ecx,8							; 4 groupboxes
					mov		esi,offset szBit7				; start from bit 7, length 10 bytes

					mov		[PortA_ID],508
					mov		[PortC_ID],524
					mov		[PortB_ID],516
					mov		[PortD_ID],532
					mov		[PortA_X],42
					mov		[PortB_X],327
					
					.while ecx > 0
						push	ebx
						push	ecx
						push	edx
						push	esi
						
						;*====	Do this for Port A bit label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, esi, 50000000h,
												PortA_X, 45, 20, 12, hWin, PortA_ID,
												hInstance,NULL
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for Port C bit label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, esi, 50000000h,
												PortA_X, 195, 20, 12, hWin, PortC_ID,
												hInstance,NULL
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for Port B bit label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, esi, 50000000h,
												PortB_X, 45, 20, 12, hWin, PortB_ID,
												hInstance,NULL
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for Port D bit label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, esi, 50000000h,
												PortB_X, 195, 20, 12, hWin, PortD_ID,
												hInstance,NULL
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						pop		esi
						pop		edx
						pop		ecx
						pop		ebx
						
						;*====	Update to next bit number	====
						add		esi,4

						add		[PortA_X],30				; go to next X position
						inc		[PortA_ID]					; and increment ID
						
						add		[PortB_X],30
						inc		[PortB_ID]
						
						inc		[PortC_ID]
						inc		[PortD_ID]					; and increment ID
						
						inc		[PortD_ID]
						dec		ecx
					.endw

					;*==============	Draw Port A-D Port bit data labels	=============================
					;*==============	Port A bit 0 label ID starts from 700	=========================
					;*==============	Port B bit 0 label ID starts from 708	=========================
					;*==============	Port C bit 0 label ID starts from 716	=========================
					;*==============	Port D bit 0 label ID starts from 724	=========================
					mov		ecx,8							; 8 labels
					mov		[hndOffs],0						; offset to handle

					mov		[PortA_D],0						; reset the port data bit state
					mov		[TrisA_D],0						;  & the tris data bit state
					
					mov		[PortB_D],0						; reset the port data bit state
					mov		[TrisB_D],0						;  & the tris data bit state
					
					mov		[PortC_D],0						; reset the port data bit state
					mov		[TrisC_D],0						;  & the tris data bit state
					
					mov		[PortD_D],0						; reset the port data bit state
					mov		[TrisD_D],0						;  & the tris data bit state
					
					mov		[PortA_ID],700					; Port A start ID
					mov		[PortC_ID],716					; Port B start ID
					mov		[PortB_ID],708					; Port C start ID
					mov		[PortD_ID],724					; Port D start ID
					mov		[PortA_X],245					; Port A bit 0 start location
					mov		[PortB_X],530					; Port B bit 0 start location
					
					.while ecx > 0
						push	ebx
						push	ecx
						push	edx
						
						;*====	Do this for Port A label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szBit0, 
												WS_CHILD or WS_VISIBLE or WS_BORDER or SS_SUNKEN or SS_NOTIFY or SS_CENTER,
												PortA_X, 65, 31, 25, hWin, PortA_ID,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hSPORTA0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for Port C label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szBit0, 
												WS_CHILD or WS_VISIBLE or WS_BORDER or SS_SUNKEN or SS_NOTIFY or SS_CENTER,
												PortA_X, 215, 31, 25, hWin, PortC_ID,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hSPORTC0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for Port B label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szBit0, 
												WS_CHILD or WS_VISIBLE or WS_BORDER or SS_SUNKEN or SS_NOTIFY or SS_CENTER,
												PortB_X, 65, 31, 25, hWin, PortB_ID,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hSPORTB0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for Port D label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szBit0, 
												WS_CHILD or WS_VISIBLE or WS_BORDER or SS_SUNKEN or SS_NOTIFY or SS_CENTER,
												PortB_X, 215, 31, 25, hWin, PortD_ID,
												hInstance,NULL
						mov		edi,[hndOffs]					; get offset to save handle
						mov		dword ptr [hSPORTD0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						pop		edx
						pop		ecx
						pop		ebx
						
						;*====	Update to next bit number	====
						add		[hndOffs],4					; next handle position
						
						sub		[PortA_X],30				; go to next X position
						sub		[PortB_X],30

						inc		[PortA_ID]					; and increment ID
						inc		[PortB_ID]
						inc		[PortC_ID]
						inc		[PortD_ID]					; and increment ID
						dec		ecx
					.endw

					;*==============	Draw Tris A-D Port bit data labels	=============================
					;*==============	TRIS A bit 0 label ID starts from 750	=========================
					;*==============	TRIS B bit 0 label ID starts from 758	=========================
					;*==============	TRIS C bit 0 label ID starts from 766	=========================
					;*==============	TRIS D bit 0 label ID starts from 774	=========================
					mov		ecx,8							; 8 labels
					mov		[hndOffs],0						; next handle position
						

					mov		[PortA_ID],750					; Tris A start ID
					mov		[PortC_ID],766					; Tris B start ID
					mov		[PortB_ID],758					; Tris C start ID
					mov		[PortD_ID],774					; Tris D start ID
					mov		[PortA_X],245					; Tris A bit 0 start location
					mov		[PortB_X],530					; Tris B bit 0 start location
					
					.while ecx > 0
						push	ebx
						push	ecx
						push	edx
						
						;*====	Do this for TRIS A label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szOut, 50000101h,
												PortA_X, 95, 31, 25, hWin, PortA_ID,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hSTRISA0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for TRIS C label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szOut, 50000101h,
												PortA_X, 245, 31, 25, hWin, PortC_ID,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hSTRISC0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for TRIS B label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szOut, 50000101h,
												PortB_X, 95, 31, 25, hWin, PortB_ID,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hSTRISB0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						;*====	Do this for TRIS D label	====
					    invoke 	CreateWindowEx,NULL,
												ADDR StaticClass, offset szOut, 50000101h,
												PortB_X, 245, 31, 25, hWin, PortD_ID,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hSTRISD0+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						pop		edx
						pop		ecx
						pop		ebx
						
						;*====	Update to next bit number	====
						add		[hndOffs],4					; next handle position
						sub		[PortA_X],30				; go to next X position
						sub		[PortB_X],30
						inc		[PortA_ID]					; and increment ID
						inc		[PortB_ID]
						inc		[PortC_ID]
						inc		[PortD_ID]					; and increment ID
						
						dec		ecx
					.endw

					;*==============	Draw 25 checkboxes	=============================
					;*==============	Checkbox start ID = 800		=====================
					mov		ecx,25							; 25 checkboxes
					mov		ebx,130							; start Y location
					mov		edx,800
					mov		[hndOffs],0						; next handle position
						
					
					.while ecx > 0
						push	ebx
						push	ecx
						push	edx
						
						;*====	Do this for checkbox	====
					    invoke 	CreateWindowEx,NULL,
												ADDR ButtonClass, offset szOut, 50010003h,
												720, ebx, 190, 12, hWin, edx,
												hInstance,NULL
						mov		edi,[hndOffs]				; get offset to save handle
						mov		dword ptr [hCHECKBOX1+edi],eax	; save label handle
						INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
						
						pop		edx
						pop		ecx
						pop		ebx

						add		[hndOffs],4					; next handle position
						inc		edx
						add		ebx,15
						dec		ecx
					.endw
	
					;*====	For loop delay checkbox	====
				    invoke 	CreateWindowEx,NULL,
											ADDR ButtonClass, offset szForLp, 50010003h,
											720, 62, 150, 12, hWin, edx,
											hInstance,NULL
					mov		[hCHECKBOXPause],eax
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE
					
					;*====	New Set button	====
					;*====	ID = 900		====
				    invoke 	CreateWindowEx,NULL,
											ADDR ButtonClass, offset szNewSet, 50010000h,
											50, 520, 120, 25, hWin, 900,
											hInstance,NULL
					mov		[hbNSet],eax
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*====	New game button	====
					;*====	ID = 901		====
				    invoke 	CreateWindowEx,NULL,
											ADDR ButtonClass, offset szNewGame, 50010000h,
											250, 520, 120, 25, hWin, 901,
											hInstance,NULL
					mov		[hbNGame],eax
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					;*====	Accept/Start game button	====
					;*====	ID = 902		====
				    invoke 	CreateWindowEx,NULL,
											ADDR ButtonClass, offset szClick, 50010000h,
											450, 520, 120, 25, hWin, 902,
											hInstance,NULL
					mov		[hbAccept],eax
					INVOKE  SendMessage, eax, WM_SETFONT, hFont, TRUE

					ret
setup_form			endp
